import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataKubernetesPodConfig extends cdktf.TerraformMetaArguments {
    /**
    * metadata block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/pod#metadata DataKubernetesPod#metadata}
    */
    readonly metadata: DataKubernetesPodMetadata;
}
export declare class DataKubernetesPodSpecAffinityNodeAffinityPreferredDuringSchedulingIgnoredDuringExecutionPreferenceMatchExpressions extends cdktf.ComplexComputedList {
    get key(): string;
    get operator(): string;
    get values(): string[];
}
export declare class DataKubernetesPodSpecAffinityNodeAffinityPreferredDuringSchedulingIgnoredDuringExecutionPreference extends cdktf.ComplexComputedList {
    get matchExpressions(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecAffinityNodeAffinityPreferredDuringSchedulingIgnoredDuringExecution extends cdktf.ComplexComputedList {
    get preference(): cdktf.IResolvable;
    get weight(): number;
}
export declare class DataKubernetesPodSpecAffinityNodeAffinityRequiredDuringSchedulingIgnoredDuringExecutionNodeSelectorTermMatchExpressions extends cdktf.ComplexComputedList {
    get key(): string;
    get operator(): string;
    get values(): string[];
}
export declare class DataKubernetesPodSpecAffinityNodeAffinityRequiredDuringSchedulingIgnoredDuringExecutionNodeSelectorTerm extends cdktf.ComplexComputedList {
    get matchExpressions(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecAffinityNodeAffinityRequiredDuringSchedulingIgnoredDuringExecution extends cdktf.ComplexComputedList {
    get nodeSelectorTerm(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecAffinityNodeAffinity extends cdktf.ComplexComputedList {
    get preferredDuringSchedulingIgnoredDuringExecution(): cdktf.IResolvable;
    get requiredDuringSchedulingIgnoredDuringExecution(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecAffinityPodAffinityPreferredDuringSchedulingIgnoredDuringExecutionPodAffinityTermLabelSelectorMatchExpressions extends cdktf.ComplexComputedList {
    get key(): string;
    get operator(): string;
    get values(): string[];
}
export declare class DataKubernetesPodSpecAffinityPodAffinityPreferredDuringSchedulingIgnoredDuringExecutionPodAffinityTermLabelSelector extends cdktf.ComplexComputedList {
    get matchExpressions(): cdktf.IResolvable;
    get matchLabels(): {
        [key: string]: string;
    };
}
export declare class DataKubernetesPodSpecAffinityPodAffinityPreferredDuringSchedulingIgnoredDuringExecutionPodAffinityTerm extends cdktf.ComplexComputedList {
    get labelSelector(): cdktf.IResolvable;
    get namespaces(): string[];
    get topologyKey(): string;
}
export declare class DataKubernetesPodSpecAffinityPodAffinityPreferredDuringSchedulingIgnoredDuringExecution extends cdktf.ComplexComputedList {
    get podAffinityTerm(): cdktf.IResolvable;
    get weight(): number;
}
export declare class DataKubernetesPodSpecAffinityPodAffinityRequiredDuringSchedulingIgnoredDuringExecutionLabelSelectorMatchExpressions extends cdktf.ComplexComputedList {
    get key(): string;
    get operator(): string;
    get values(): string[];
}
export declare class DataKubernetesPodSpecAffinityPodAffinityRequiredDuringSchedulingIgnoredDuringExecutionLabelSelector extends cdktf.ComplexComputedList {
    get matchExpressions(): cdktf.IResolvable;
    get matchLabels(): {
        [key: string]: string;
    };
}
export declare class DataKubernetesPodSpecAffinityPodAffinityRequiredDuringSchedulingIgnoredDuringExecution extends cdktf.ComplexComputedList {
    get labelSelector(): cdktf.IResolvable;
    get namespaces(): string[];
    get topologyKey(): string;
}
export declare class DataKubernetesPodSpecAffinityPodAffinity extends cdktf.ComplexComputedList {
    get preferredDuringSchedulingIgnoredDuringExecution(): cdktf.IResolvable;
    get requiredDuringSchedulingIgnoredDuringExecution(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecAffinityPodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionPodAffinityTermLabelSelectorMatchExpressions extends cdktf.ComplexComputedList {
    get key(): string;
    get operator(): string;
    get values(): string[];
}
export declare class DataKubernetesPodSpecAffinityPodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionPodAffinityTermLabelSelector extends cdktf.ComplexComputedList {
    get matchExpressions(): cdktf.IResolvable;
    get matchLabels(): {
        [key: string]: string;
    };
}
export declare class DataKubernetesPodSpecAffinityPodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecutionPodAffinityTerm extends cdktf.ComplexComputedList {
    get labelSelector(): cdktf.IResolvable;
    get namespaces(): string[];
    get topologyKey(): string;
}
export declare class DataKubernetesPodSpecAffinityPodAntiAffinityPreferredDuringSchedulingIgnoredDuringExecution extends cdktf.ComplexComputedList {
    get podAffinityTerm(): cdktf.IResolvable;
    get weight(): number;
}
export declare class DataKubernetesPodSpecAffinityPodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionLabelSelectorMatchExpressions extends cdktf.ComplexComputedList {
    get key(): string;
    get operator(): string;
    get values(): string[];
}
export declare class DataKubernetesPodSpecAffinityPodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecutionLabelSelector extends cdktf.ComplexComputedList {
    get matchExpressions(): cdktf.IResolvable;
    get matchLabels(): {
        [key: string]: string;
    };
}
export declare class DataKubernetesPodSpecAffinityPodAntiAffinityRequiredDuringSchedulingIgnoredDuringExecution extends cdktf.ComplexComputedList {
    get labelSelector(): cdktf.IResolvable;
    get namespaces(): string[];
    get topologyKey(): string;
}
export declare class DataKubernetesPodSpecAffinityPodAntiAffinity extends cdktf.ComplexComputedList {
    get preferredDuringSchedulingIgnoredDuringExecution(): cdktf.IResolvable;
    get requiredDuringSchedulingIgnoredDuringExecution(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecAffinity extends cdktf.ComplexComputedList {
    get nodeAffinity(): cdktf.IResolvable;
    get podAffinity(): cdktf.IResolvable;
    get podAntiAffinity(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerEnvValueFromConfigMapKeyRef extends cdktf.ComplexComputedList {
    get key(): string;
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerEnvValueFromFieldRef extends cdktf.ComplexComputedList {
    get apiVersion(): string;
    get fieldPath(): string;
}
export declare class DataKubernetesPodSpecContainerEnvValueFromResourceFieldRef extends cdktf.ComplexComputedList {
    get containerName(): string;
    get divisor(): string;
    get resource(): string;
}
export declare class DataKubernetesPodSpecContainerEnvValueFromSecretKeyRef extends cdktf.ComplexComputedList {
    get key(): string;
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerEnvValueFrom extends cdktf.ComplexComputedList {
    get configMapKeyRef(): cdktf.IResolvable;
    get fieldRef(): cdktf.IResolvable;
    get resourceFieldRef(): cdktf.IResolvable;
    get secretKeyRef(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerEnv extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
    get valueFrom(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerEnvFromConfigMapRef extends cdktf.ComplexComputedList {
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerEnvFromSecretRef extends cdktf.ComplexComputedList {
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerEnvFrom extends cdktf.ComplexComputedList {
    get configMapRef(): cdktf.IResolvable;
    get prefix(): string;
    get secretRef(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerLifecyclePostStartExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecContainerLifecyclePostStartHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecContainerLifecyclePostStartHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecContainerLifecyclePostStartTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecContainerLifecyclePostStart extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get httpGet(): cdktf.IResolvable;
    get tcpSocket(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerLifecyclePreStopExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecContainerLifecyclePreStopHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecContainerLifecyclePreStopHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecContainerLifecyclePreStopTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecContainerLifecyclePreStop extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get httpGet(): cdktf.IResolvable;
    get tcpSocket(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerLifecycle extends cdktf.ComplexComputedList {
    get postStart(): cdktf.IResolvable;
    get preStop(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerLivenessProbeExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecContainerLivenessProbeHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecContainerLivenessProbeHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecContainerLivenessProbeTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecContainerLivenessProbe extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get failureThreshold(): number;
    get httpGet(): cdktf.IResolvable;
    get initialDelaySeconds(): number;
    get periodSeconds(): number;
    get successThreshold(): number;
    get tcpSocket(): cdktf.IResolvable;
    get timeoutSeconds(): number;
}
export declare class DataKubernetesPodSpecContainerPort extends cdktf.ComplexComputedList {
    get containerPort(): number;
    get hostIp(): string;
    get hostPort(): number;
    get name(): string;
    get protocol(): string;
}
export declare class DataKubernetesPodSpecContainerReadinessProbeExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecContainerReadinessProbeHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecContainerReadinessProbeHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecContainerReadinessProbeTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecContainerReadinessProbe extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get failureThreshold(): number;
    get httpGet(): cdktf.IResolvable;
    get initialDelaySeconds(): number;
    get periodSeconds(): number;
    get successThreshold(): number;
    get tcpSocket(): cdktf.IResolvable;
    get timeoutSeconds(): number;
}
export declare class DataKubernetesPodSpecContainerResources extends cdktf.ComplexComputedList {
    get limits(): {
        [key: string]: string;
    };
    get requests(): {
        [key: string]: string;
    };
}
export declare class DataKubernetesPodSpecContainerSecurityContextCapabilities extends cdktf.ComplexComputedList {
    get add(): string[];
    get drop(): string[];
}
export declare class DataKubernetesPodSpecContainerSecurityContextSeLinuxOptions extends cdktf.ComplexComputedList {
    get level(): string;
    get role(): string;
    get type(): string;
    get user(): string;
}
export declare class DataKubernetesPodSpecContainerSecurityContext extends cdktf.ComplexComputedList {
    get allowPrivilegeEscalation(): cdktf.IResolvable;
    get capabilities(): cdktf.IResolvable;
    get privileged(): cdktf.IResolvable;
    get readOnlyRootFilesystem(): cdktf.IResolvable;
    get runAsGroup(): string;
    get runAsNonRoot(): cdktf.IResolvable;
    get runAsUser(): string;
    get seLinuxOptions(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecContainerStartupProbeExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecContainerStartupProbeHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecContainerStartupProbeHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecContainerStartupProbeTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecContainerStartupProbe extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get failureThreshold(): number;
    get httpGet(): cdktf.IResolvable;
    get initialDelaySeconds(): number;
    get periodSeconds(): number;
    get successThreshold(): number;
    get tcpSocket(): cdktf.IResolvable;
    get timeoutSeconds(): number;
}
export declare class DataKubernetesPodSpecContainerVolumeMount extends cdktf.ComplexComputedList {
    get mountPath(): string;
    get mountPropagation(): string;
    get name(): string;
    get readOnly(): cdktf.IResolvable;
    get subPath(): string;
}
export declare class DataKubernetesPodSpecContainer extends cdktf.ComplexComputedList {
    get args(): string[];
    get command(): string[];
    get env(): cdktf.IResolvable;
    get envFrom(): cdktf.IResolvable;
    get image(): string;
    get imagePullPolicy(): string;
    get lifecycle(): cdktf.IResolvable;
    get livenessProbe(): cdktf.IResolvable;
    get name(): string;
    get port(): cdktf.IResolvable;
    get readinessProbe(): cdktf.IResolvable;
    get resources(): cdktf.IResolvable;
    get securityContext(): cdktf.IResolvable;
    get startupProbe(): cdktf.IResolvable;
    get stdin(): cdktf.IResolvable;
    get stdinOnce(): cdktf.IResolvable;
    get terminationMessagePath(): string;
    get terminationMessagePolicy(): string;
    get tty(): cdktf.IResolvable;
    get volumeMount(): cdktf.IResolvable;
    get workingDir(): string;
}
export declare class DataKubernetesPodSpecDnsConfigOption extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecDnsConfig extends cdktf.ComplexComputedList {
    get nameservers(): string[];
    get option(): cdktf.IResolvable;
    get searches(): string[];
}
export declare class DataKubernetesPodSpecHostAliases extends cdktf.ComplexComputedList {
    get hostnames(): string[];
    get ip(): string;
}
export declare class DataKubernetesPodSpecImagePullSecrets extends cdktf.ComplexComputedList {
    get name(): string;
}
export declare class DataKubernetesPodSpecInitContainerEnvValueFromConfigMapKeyRef extends cdktf.ComplexComputedList {
    get key(): string;
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerEnvValueFromFieldRef extends cdktf.ComplexComputedList {
    get apiVersion(): string;
    get fieldPath(): string;
}
export declare class DataKubernetesPodSpecInitContainerEnvValueFromResourceFieldRef extends cdktf.ComplexComputedList {
    get containerName(): string;
    get divisor(): string;
    get resource(): string;
}
export declare class DataKubernetesPodSpecInitContainerEnvValueFromSecretKeyRef extends cdktf.ComplexComputedList {
    get key(): string;
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerEnvValueFrom extends cdktf.ComplexComputedList {
    get configMapKeyRef(): cdktf.IResolvable;
    get fieldRef(): cdktf.IResolvable;
    get resourceFieldRef(): cdktf.IResolvable;
    get secretKeyRef(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerEnv extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
    get valueFrom(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerEnvFromConfigMapRef extends cdktf.ComplexComputedList {
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerEnvFromSecretRef extends cdktf.ComplexComputedList {
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerEnvFrom extends cdktf.ComplexComputedList {
    get configMapRef(): cdktf.IResolvable;
    get prefix(): string;
    get secretRef(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePostStartExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePostStartHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePostStartHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePostStartTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePostStart extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get httpGet(): cdktf.IResolvable;
    get tcpSocket(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePreStopExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePreStopHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePreStopHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePreStopTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecInitContainerLifecyclePreStop extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get httpGet(): cdktf.IResolvable;
    get tcpSocket(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerLifecycle extends cdktf.ComplexComputedList {
    get postStart(): cdktf.IResolvable;
    get preStop(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerLivenessProbeExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecInitContainerLivenessProbeHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecInitContainerLivenessProbeHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecInitContainerLivenessProbeTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecInitContainerLivenessProbe extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get failureThreshold(): number;
    get httpGet(): cdktf.IResolvable;
    get initialDelaySeconds(): number;
    get periodSeconds(): number;
    get successThreshold(): number;
    get tcpSocket(): cdktf.IResolvable;
    get timeoutSeconds(): number;
}
export declare class DataKubernetesPodSpecInitContainerPort extends cdktf.ComplexComputedList {
    get containerPort(): number;
    get hostIp(): string;
    get hostPort(): number;
    get name(): string;
    get protocol(): string;
}
export declare class DataKubernetesPodSpecInitContainerReadinessProbeExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecInitContainerReadinessProbeHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecInitContainerReadinessProbeHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecInitContainerReadinessProbeTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecInitContainerReadinessProbe extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get failureThreshold(): number;
    get httpGet(): cdktf.IResolvable;
    get initialDelaySeconds(): number;
    get periodSeconds(): number;
    get successThreshold(): number;
    get tcpSocket(): cdktf.IResolvable;
    get timeoutSeconds(): number;
}
export declare class DataKubernetesPodSpecInitContainerResources extends cdktf.ComplexComputedList {
    get limits(): {
        [key: string]: string;
    };
    get requests(): {
        [key: string]: string;
    };
}
export declare class DataKubernetesPodSpecInitContainerSecurityContextCapabilities extends cdktf.ComplexComputedList {
    get add(): string[];
    get drop(): string[];
}
export declare class DataKubernetesPodSpecInitContainerSecurityContextSeLinuxOptions extends cdktf.ComplexComputedList {
    get level(): string;
    get role(): string;
    get type(): string;
    get user(): string;
}
export declare class DataKubernetesPodSpecInitContainerSecurityContext extends cdktf.ComplexComputedList {
    get allowPrivilegeEscalation(): cdktf.IResolvable;
    get capabilities(): cdktf.IResolvable;
    get privileged(): cdktf.IResolvable;
    get readOnlyRootFilesystem(): cdktf.IResolvable;
    get runAsGroup(): string;
    get runAsNonRoot(): cdktf.IResolvable;
    get runAsUser(): string;
    get seLinuxOptions(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecInitContainerStartupProbeExec extends cdktf.ComplexComputedList {
    get command(): string[];
}
export declare class DataKubernetesPodSpecInitContainerStartupProbeHttpGetHttpHeader extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecInitContainerStartupProbeHttpGet extends cdktf.ComplexComputedList {
    get host(): string;
    get httpHeader(): cdktf.IResolvable;
    get path(): string;
    get port(): string;
    get scheme(): string;
}
export declare class DataKubernetesPodSpecInitContainerStartupProbeTcpSocket extends cdktf.ComplexComputedList {
    get port(): string;
}
export declare class DataKubernetesPodSpecInitContainerStartupProbe extends cdktf.ComplexComputedList {
    get exec(): cdktf.IResolvable;
    get failureThreshold(): number;
    get httpGet(): cdktf.IResolvable;
    get initialDelaySeconds(): number;
    get periodSeconds(): number;
    get successThreshold(): number;
    get tcpSocket(): cdktf.IResolvable;
    get timeoutSeconds(): number;
}
export declare class DataKubernetesPodSpecInitContainerVolumeMount extends cdktf.ComplexComputedList {
    get mountPath(): string;
    get mountPropagation(): string;
    get name(): string;
    get readOnly(): cdktf.IResolvable;
    get subPath(): string;
}
export declare class DataKubernetesPodSpecInitContainer extends cdktf.ComplexComputedList {
    get args(): string[];
    get command(): string[];
    get env(): cdktf.IResolvable;
    get envFrom(): cdktf.IResolvable;
    get image(): string;
    get imagePullPolicy(): string;
    get lifecycle(): cdktf.IResolvable;
    get livenessProbe(): cdktf.IResolvable;
    get name(): string;
    get port(): cdktf.IResolvable;
    get readinessProbe(): cdktf.IResolvable;
    get resources(): cdktf.IResolvable;
    get securityContext(): cdktf.IResolvable;
    get startupProbe(): cdktf.IResolvable;
    get stdin(): cdktf.IResolvable;
    get stdinOnce(): cdktf.IResolvable;
    get terminationMessagePath(): string;
    get terminationMessagePolicy(): string;
    get tty(): cdktf.IResolvable;
    get volumeMount(): cdktf.IResolvable;
    get workingDir(): string;
}
export declare class DataKubernetesPodSpecReadinessGate extends cdktf.ComplexComputedList {
    get conditionType(): string;
}
export declare class DataKubernetesPodSpecSecurityContextSeLinuxOptions extends cdktf.ComplexComputedList {
    get level(): string;
    get role(): string;
    get type(): string;
    get user(): string;
}
export declare class DataKubernetesPodSpecSecurityContextSysctl extends cdktf.ComplexComputedList {
    get name(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecSecurityContext extends cdktf.ComplexComputedList {
    get fsGroup(): string;
    get runAsGroup(): string;
    get runAsNonRoot(): cdktf.IResolvable;
    get runAsUser(): string;
    get seLinuxOptions(): cdktf.IResolvable;
    get supplementalGroups(): number[];
    get sysctl(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecToleration extends cdktf.ComplexComputedList {
    get effect(): string;
    get key(): string;
    get operator(): string;
    get tolerationSeconds(): string;
    get value(): string;
}
export declare class DataKubernetesPodSpecTopologySpreadConstraintLabelSelectorMatchExpressions extends cdktf.ComplexComputedList {
    get key(): string;
    get operator(): string;
    get values(): string[];
}
export declare class DataKubernetesPodSpecTopologySpreadConstraintLabelSelector extends cdktf.ComplexComputedList {
    get matchExpressions(): cdktf.IResolvable;
    get matchLabels(): {
        [key: string]: string;
    };
}
export declare class DataKubernetesPodSpecTopologySpreadConstraint extends cdktf.ComplexComputedList {
    get labelSelector(): cdktf.IResolvable;
    get maxSkew(): number;
    get topologyKey(): string;
    get whenUnsatisfiable(): string;
}
export declare class DataKubernetesPodSpecVolumeAwsElasticBlockStore extends cdktf.ComplexComputedList {
    get fsType(): string;
    get partition(): number;
    get readOnly(): cdktf.IResolvable;
    get volumeId(): string;
}
export declare class DataKubernetesPodSpecVolumeAzureDisk extends cdktf.ComplexComputedList {
    get cachingMode(): string;
    get dataDiskUri(): string;
    get diskName(): string;
    get fsType(): string;
    get kind(): string;
    get readOnly(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeAzureFile extends cdktf.ComplexComputedList {
    get readOnly(): cdktf.IResolvable;
    get secretName(): string;
    get secretNamespace(): string;
    get shareName(): string;
}
export declare class DataKubernetesPodSpecVolumeCephFsSecretRef extends cdktf.ComplexComputedList {
    get name(): string;
    get namespace(): string;
}
export declare class DataKubernetesPodSpecVolumeCephFs extends cdktf.ComplexComputedList {
    get monitors(): string[];
    get path(): string;
    get readOnly(): cdktf.IResolvable;
    get secretFile(): string;
    get secretRef(): cdktf.IResolvable;
    get user(): string;
}
export declare class DataKubernetesPodSpecVolumeCinder extends cdktf.ComplexComputedList {
    get fsType(): string;
    get readOnly(): cdktf.IResolvable;
    get volumeId(): string;
}
export declare class DataKubernetesPodSpecVolumeConfigMapItems extends cdktf.ComplexComputedList {
    get key(): string;
    get mode(): string;
    get path(): string;
}
export declare class DataKubernetesPodSpecVolumeConfigMap extends cdktf.ComplexComputedList {
    get defaultMode(): string;
    get items(): cdktf.IResolvable;
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeCsiControllerExpandSecretRef extends cdktf.ComplexComputedList {
    get name(): string;
    get namespace(): string;
}
export declare class DataKubernetesPodSpecVolumeCsiControllerPublishSecretRef extends cdktf.ComplexComputedList {
    get name(): string;
    get namespace(): string;
}
export declare class DataKubernetesPodSpecVolumeCsiNodePublishSecretRef extends cdktf.ComplexComputedList {
    get name(): string;
    get namespace(): string;
}
export declare class DataKubernetesPodSpecVolumeCsiNodeStageSecretRef extends cdktf.ComplexComputedList {
    get name(): string;
    get namespace(): string;
}
export declare class DataKubernetesPodSpecVolumeCsi extends cdktf.ComplexComputedList {
    get controllerExpandSecretRef(): cdktf.IResolvable;
    get controllerPublishSecretRef(): cdktf.IResolvable;
    get driver(): string;
    get fsType(): string;
    get nodePublishSecretRef(): cdktf.IResolvable;
    get nodeStageSecretRef(): cdktf.IResolvable;
    get readOnly(): cdktf.IResolvable;
    get volumeAttributes(): {
        [key: string]: string;
    };
    get volumeHandle(): string;
}
export declare class DataKubernetesPodSpecVolumeDownwardApiItemsFieldRef extends cdktf.ComplexComputedList {
    get apiVersion(): string;
    get fieldPath(): string;
}
export declare class DataKubernetesPodSpecVolumeDownwardApiItemsResourceFieldRef extends cdktf.ComplexComputedList {
    get containerName(): string;
    get divisor(): string;
    get resource(): string;
}
export declare class DataKubernetesPodSpecVolumeDownwardApiItems extends cdktf.ComplexComputedList {
    get fieldRef(): cdktf.IResolvable;
    get mode(): string;
    get path(): string;
    get resourceFieldRef(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeDownwardApi extends cdktf.ComplexComputedList {
    get defaultMode(): string;
    get items(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeEmptyDir extends cdktf.ComplexComputedList {
    get medium(): string;
    get sizeLimit(): string;
}
export declare class DataKubernetesPodSpecVolumeFc extends cdktf.ComplexComputedList {
    get fsType(): string;
    get lun(): number;
    get readOnly(): cdktf.IResolvable;
    get targetWwNs(): string[];
}
export declare class DataKubernetesPodSpecVolumeFlexVolumeSecretRef extends cdktf.ComplexComputedList {
    get name(): string;
    get namespace(): string;
}
export declare class DataKubernetesPodSpecVolumeFlexVolume extends cdktf.ComplexComputedList {
    get driver(): string;
    get fsType(): string;
    get options(): {
        [key: string]: string;
    };
    get readOnly(): cdktf.IResolvable;
    get secretRef(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeFlocker extends cdktf.ComplexComputedList {
    get datasetName(): string;
    get datasetUuid(): string;
}
export declare class DataKubernetesPodSpecVolumeGcePersistentDisk extends cdktf.ComplexComputedList {
    get fsType(): string;
    get partition(): number;
    get pdName(): string;
    get readOnly(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeGitRepo extends cdktf.ComplexComputedList {
    get directory(): string;
    get repository(): string;
    get revision(): string;
}
export declare class DataKubernetesPodSpecVolumeGlusterfs extends cdktf.ComplexComputedList {
    get endpointsName(): string;
    get path(): string;
    get readOnly(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeHostPath extends cdktf.ComplexComputedList {
    get path(): string;
    get type(): string;
}
export declare class DataKubernetesPodSpecVolumeIscsi extends cdktf.ComplexComputedList {
    get fsType(): string;
    get iqn(): string;
    get iscsiInterface(): string;
    get lun(): number;
    get readOnly(): cdktf.IResolvable;
    get targetPortal(): string;
}
export declare class DataKubernetesPodSpecVolumeLocal extends cdktf.ComplexComputedList {
    get path(): string;
}
export declare class DataKubernetesPodSpecVolumeNfs extends cdktf.ComplexComputedList {
    get path(): string;
    get readOnly(): cdktf.IResolvable;
    get server(): string;
}
export declare class DataKubernetesPodSpecVolumePersistentVolumeClaim extends cdktf.ComplexComputedList {
    get claimName(): string;
    get readOnly(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumePhotonPersistentDisk extends cdktf.ComplexComputedList {
    get fsType(): string;
    get pdId(): string;
}
export declare class DataKubernetesPodSpecVolumeProjectedSourcesConfigMapItems extends cdktf.ComplexComputedList {
    get key(): string;
    get mode(): string;
    get path(): string;
}
export declare class DataKubernetesPodSpecVolumeProjectedSourcesConfigMap extends cdktf.ComplexComputedList {
    get items(): cdktf.IResolvable;
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeProjectedSourcesDownwardApiItemsFieldRef extends cdktf.ComplexComputedList {
    get apiVersion(): string;
    get fieldPath(): string;
}
export declare class DataKubernetesPodSpecVolumeProjectedSourcesDownwardApiItemsResourceFieldRef extends cdktf.ComplexComputedList {
    get containerName(): string;
    get divisor(): string;
    get resource(): string;
}
export declare class DataKubernetesPodSpecVolumeProjectedSourcesDownwardApiItems extends cdktf.ComplexComputedList {
    get fieldRef(): cdktf.IResolvable;
    get mode(): string;
    get path(): string;
    get resourceFieldRef(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeProjectedSourcesDownwardApi extends cdktf.ComplexComputedList {
    get items(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeProjectedSourcesSecretItems extends cdktf.ComplexComputedList {
    get key(): string;
    get mode(): string;
    get path(): string;
}
export declare class DataKubernetesPodSpecVolumeProjectedSourcesSecret extends cdktf.ComplexComputedList {
    get items(): cdktf.IResolvable;
    get name(): string;
    get optional(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeProjectedSourcesServiceAccountToken extends cdktf.ComplexComputedList {
    get audience(): string;
    get expirationSeconds(): number;
    get path(): string;
}
export declare class DataKubernetesPodSpecVolumeProjectedSources extends cdktf.ComplexComputedList {
    get configMap(): cdktf.IResolvable;
    get downwardApi(): cdktf.IResolvable;
    get secret(): cdktf.IResolvable;
    get serviceAccountToken(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeProjected extends cdktf.ComplexComputedList {
    get defaultMode(): string;
    get sources(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeQuobyte extends cdktf.ComplexComputedList {
    get group(): string;
    get readOnly(): cdktf.IResolvable;
    get registry(): string;
    get user(): string;
    get volume(): string;
}
export declare class DataKubernetesPodSpecVolumeRbdSecretRef extends cdktf.ComplexComputedList {
    get name(): string;
    get namespace(): string;
}
export declare class DataKubernetesPodSpecVolumeRbd extends cdktf.ComplexComputedList {
    get cephMonitors(): string[];
    get fsType(): string;
    get keyring(): string;
    get radosUser(): string;
    get rbdImage(): string;
    get rbdPool(): string;
    get readOnly(): cdktf.IResolvable;
    get secretRef(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpecVolumeSecretItems extends cdktf.ComplexComputedList {
    get key(): string;
    get mode(): string;
    get path(): string;
}
export declare class DataKubernetesPodSpecVolumeSecret extends cdktf.ComplexComputedList {
    get defaultMode(): string;
    get items(): cdktf.IResolvable;
    get optional(): cdktf.IResolvable;
    get secretName(): string;
}
export declare class DataKubernetesPodSpecVolumeVsphereVolume extends cdktf.ComplexComputedList {
    get fsType(): string;
    get volumePath(): string;
}
export declare class DataKubernetesPodSpecVolume extends cdktf.ComplexComputedList {
    get awsElasticBlockStore(): cdktf.IResolvable;
    get azureDisk(): cdktf.IResolvable;
    get azureFile(): cdktf.IResolvable;
    get cephFs(): cdktf.IResolvable;
    get cinder(): cdktf.IResolvable;
    get configMap(): cdktf.IResolvable;
    get csi(): cdktf.IResolvable;
    get downwardApi(): cdktf.IResolvable;
    get emptyDir(): cdktf.IResolvable;
    get fc(): cdktf.IResolvable;
    get flexVolume(): cdktf.IResolvable;
    get flocker(): cdktf.IResolvable;
    get gcePersistentDisk(): cdktf.IResolvable;
    get gitRepo(): cdktf.IResolvable;
    get glusterfs(): cdktf.IResolvable;
    get hostPath(): cdktf.IResolvable;
    get iscsi(): cdktf.IResolvable;
    get local(): cdktf.IResolvable;
    get name(): string;
    get nfs(): cdktf.IResolvable;
    get persistentVolumeClaim(): cdktf.IResolvable;
    get photonPersistentDisk(): cdktf.IResolvable;
    get projected(): cdktf.IResolvable;
    get quobyte(): cdktf.IResolvable;
    get rbd(): cdktf.IResolvable;
    get secret(): cdktf.IResolvable;
    get vsphereVolume(): cdktf.IResolvable;
}
export declare class DataKubernetesPodSpec extends cdktf.ComplexComputedList {
    get activeDeadlineSeconds(): number;
    get affinity(): cdktf.IResolvable;
    get automountServiceAccountToken(): cdktf.IResolvable;
    get container(): cdktf.IResolvable;
    get dnsConfig(): cdktf.IResolvable;
    get dnsPolicy(): string;
    get enableServiceLinks(): cdktf.IResolvable;
    get hostAliases(): cdktf.IResolvable;
    get hostIpc(): cdktf.IResolvable;
    get hostNetwork(): cdktf.IResolvable;
    get hostPid(): cdktf.IResolvable;
    get hostname(): string;
    get imagePullSecrets(): cdktf.IResolvable;
    get initContainer(): cdktf.IResolvable;
    get nodeName(): string;
    get nodeSelector(): {
        [key: string]: string;
    };
    get priorityClassName(): string;
    get readinessGate(): cdktf.IResolvable;
    get restartPolicy(): string;
    get securityContext(): cdktf.IResolvable;
    get serviceAccountName(): string;
    get shareProcessNamespace(): cdktf.IResolvable;
    get subdomain(): string;
    get terminationGracePeriodSeconds(): number;
    get toleration(): cdktf.IResolvable;
    get topologySpreadConstraint(): cdktf.IResolvable;
    get volume(): cdktf.IResolvable;
}
export interface DataKubernetesPodMetadata {
    /**
    * An unstructured key value map stored with the pod that may be used to store arbitrary metadata. More info: http://kubernetes.io/docs/user-guide/annotations
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/pod#annotations DataKubernetesPod#annotations}
    */
    readonly annotations?: {
        [key: string]: string;
    };
    /**
    * Prefix, used by the server, to generate a unique name ONLY IF the `name` field has not been provided. This value will also be combined with a unique suffix. Read more: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#idempotency
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/pod#generate_name DataKubernetesPod#generate_name}
    */
    readonly generateName?: string;
    /**
    * Map of string keys and values that can be used to organize and categorize (scope and select) the pod. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/pod#labels DataKubernetesPod#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Name of the pod, must be unique. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/pod#name DataKubernetesPod#name}
    */
    readonly name?: string;
    /**
    * Namespace defines the space within which name of the pod must be unique.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/pod#namespace DataKubernetesPod#namespace}
    */
    readonly namespace?: string;
}
export declare function dataKubernetesPodMetadataToTerraform(struct?: DataKubernetesPodMetadataOutputReference | DataKubernetesPodMetadata): any;
export declare class DataKubernetesPodMetadataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): DataKubernetesPodMetadata | undefined;
    set internalValue(value: DataKubernetesPodMetadata | undefined);
    private _annotations?;
    get annotations(): {
        [key: string]: string;
    };
    set annotations(value: {
        [key: string]: string;
    });
    resetAnnotations(): void;
    get annotationsInput(): {
        [key: string]: string;
    } | undefined;
    private _generateName?;
    get generateName(): string;
    set generateName(value: string);
    resetGenerateName(): void;
    get generateNameInput(): string | undefined;
    get generation(): number;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    resetNamespace(): void;
    get namespaceInput(): string | undefined;
    get resourceVersion(): string;
    get uid(): string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/kubernetes/d/pod kubernetes_pod}
*/
export declare class DataKubernetesPod extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/kubernetes/d/pod kubernetes_pod} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataKubernetesPodConfig
    */
    constructor(scope: Construct, id: string, config: DataKubernetesPodConfig);
    get id(): string;
    spec(index: string): DataKubernetesPodSpec;
    get status(): string;
    private _metadata;
    get metadata(): DataKubernetesPodMetadataOutputReference;
    putMetadata(value: DataKubernetesPodMetadata): void;
    get metadataInput(): DataKubernetesPodMetadata | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
